diff --git a/ent/src/yb/integration-tests/cdcsdk_ysql-test.cc b/ent/src/yb/integration-tests/cdcsdk_ysql-test.cc
index 154a5ff37ed4..ea0dc1c5142e 100644
--- a/ent/src/yb/integration-tests/cdcsdk_ysql-test.cc
+++ b/ent/src/yb/integration-tests/cdcsdk_ysql-test.cc
@@ -7574,7 +7574,7 @@ TEST_F(CDCSDKYsqlTest, YB_DISABLE_TEST_IN_TSAN(TestAddMultipleTableToNamespaceWi
   // not be added to the stream.
   ASSERT_OK(CreateTableWithoutPK(&test_cluster_));
 
-  // Add 5 more tables after the stream is created.
+  // Add 3 more tables after the stream is created.
   for (uint32_t i = 1; i <= num_new_tables; ++i) {
     std::string table_name = "test_table_" + std::to_string(i);
     auto table =
@@ -7604,7 +7604,9 @@ TEST_F(CDCSDKYsqlTest, YB_DISABLE_TEST_IN_TSAN(TestAddMultipleTableToNamespaceWi
 }
 
 TEST_F(CDCSDKYsqlTest, YB_DISABLE_TEST_IN_TSAN(TestIntentGCedWithTabletBootStrap)) {
+  FLAGS_enable_load_balancing = false;
   FLAGS_update_min_cdc_indices_interval_secs = 1;
+
   ASSERT_OK(SetUpWithParams(3, 1, false));
 
   const uint32_t num_tablets = 1;
diff --git a/ent/src/yb/master/catalog_manager_ent.cc b/ent/src/yb/master/catalog_manager_ent.cc
index 3595b2038b86..f1ab0241805b 100644
--- a/ent/src/yb/master/catalog_manager_ent.cc
+++ b/ent/src/yb/master/catalog_manager_ent.cc
@@ -3818,15 +3818,20 @@ Status CatalogManager::FindCDCSDKStreamsForAddedTables(
           LOG(WARNING) << "Error while getting schema for table: " << table->name();
           continue;
         }
+        bool has_pk = true;
         for (const auto& col : schema.columns()) {
           if (col.order() == static_cast<int32_t>(PgSystemAttrNum::kYBRowId)) {
             // ybrowid column is added for tables that don't have user-specified primary key.
             RemoveTableFromCDCSDKUnprocessedSet(table_id, stream_info);
             VLOG(1) << "Table: " << table_id
                     << ", will not be added to CDCSDK stream, since it does not have a primary key";
-            continue;
+            has_pk = false;
+            break;
           }
         }
+        if (!has_pk) {
+          continue;
+        }
 
         if (std::find(ltm->table_id().begin(), ltm->table_id().end(), table_id) ==
             ltm->table_id().end()) {
